/*
 * pemc-test.cc    Test program for P-E-M-C, exercise CRTP, Step 1.
 */
#include "CRN.h"
#include "Date.h"
#include "Person.h"
#include "Employee.h"
#include <iomanip>
#include <iostream>
#include <vector>
#include <typeinfo>
using namespace std;
using namespace IDA_Person;
using namespace IDA_Date;

int main()
{
   Employee e{ "Beth Saida", CRN{ 1952,2,1,1021 }, Date{ 2007,1,2 }, 2, 12000.00 };
// Employee e2{ e };  // error: protected in this context
// e = e2;            // error: use of deleted function

   vector<Employee*> employees{
      new Employee{ "Beth Saida", CRN{ 1952,2,1,1021 }, Date{ 2007,1,2 }, 2, 12000.00 },
      new Employee{ "Carl Ovignan", CRN{ 1953,3,1,1031 }, Date{ 2007,1,3 }, 3, 13000.00 },
      new Employee{ "Dan Druff", CRN{ 1954,4,1,1041 }, Date{ 2007,1,4 }, 4, 14000.00 },
      new Employee{ "Erica Ceous", CRN{ 1955,5,1,1051 }, Date{ 2007,1,5 }, 5, 15000.00 },
      new Employee{ "Herb Acious", CRN{ 1955,5,1,1051 }, Date{ 2007,1,8 }, 5, 17000.00 },
      new Employee{ "Ivan Hoe",  CRN{ 1955,5,1,1051 }, Date{ 2007,1,9 }, 5, 12000.00 },
      new Employee{ "Jack Aroo", CRN{ 1955,5,1,1051 }, Date{ 2007,1,10 }, 5, 11000.00 },
      new Employee{ "Kale Yard", CRN{ 1955,5,1,1052 }, Date{ 2007,1,11 }, 5, 15000.00 },
   };

   cout << "Employee list\n" << setfill('-') << setw(52) << '-' << setfill(' ') << '\n';
   for (auto ep : employees)
   {
      cout << ep->str() << '\n';
   }
   cout << '\n';

   // Test clone() 

   cout << "An Employee is cloned:\n";
   Person* c{ (*begin(employees))->clone() };
   cout << c->str() << '\n';
   delete c;
   c = nullptr;

   // Deallocate employees in list and set pointers to null pointers (just for the exercise)
   for (auto& ep : employees)
   {
      delete ep;
      ep = nullptr;
   }

   return 0;
}
